%%% -*- indent-tabs-mode: nil -*-
%%%
%%% Author:
%%%   Andreas Franke <afranke@ags.uni-sb.de>
%%%
%%% Copyright:
%%%   Andreas Franke, 2000
%%%
%%% Last change:
%%%   $Date: 2001/08/10 11:26:03 $ by $Author: afranke $
%%%   $Revision: 1.5 $
%%%
%%% This file is part of MathWeb
%%%    http://www.mathweb.org/mathweb
%%%
%%% See the file "LICENSE" or
%%%    http://www.mathweb.org/mathweb/LICENSE.html
%%% for information on usage and redistribution
%%% of this file, and for a DISCLAIMER OF ALL
%%% WARRANTIES.
%%%

%%
%% HTTP handlers
%%

functor

import
   %%System(show)
   
export
   'class': XmlRpcHandler

define

   %%VS2BS = VirtualString.toByteString
   VS2S = VirtualString.toString
   
   %%
   %% the XmlRpcHandler class
   %%
   class XmlRpcHandler 
      attr
         xmlrpcServer: unit
         
      meth init(XMLRPCServer<=unit)
         xmlrpcServer <- XMLRPCServer
      end
      
      /** called from the XmlRpcServer. This method should be overridden */
      meth execute(MethodNameVS Params ?Result)   
         case {VS2S MethodNameVS}
         of "ping" then
            XmlRpcHandler, exec_ping(Params ?Result)
         else
            raise fault(1 "unknown method: "#MethodNameVS) end
         end
      end
      
      %%
      %% and here an example method for <methodName> == "ping"
      %%
      meth exec_ping(_ ?Result)
         Result = "pong"
      end

   end  % class XmlRpcHandler

end % define


%       %%
%       %% setters & getters for Name and Context attributes
%       %%
%       /*
%       meth setName(NameVS)
%          Name <- {VS2BS NameVS}
%       end
%       meth getName($)
%          @Name
%       end
%       %%
%       meth initialize(TheContext)
%          if @Context==unit then
%             Context <- TheContext
%          elseif @Context\=TheContext then
%             raise illegalState(contextMismatch) end
%          end
%       end
%       meth getContext($)
%          @Context
%       end
%       */
      
%       %%
%       %% LifeCycle stuff
%       %%
%       /*
%       %%
%       meth start()
%          if @Context==unit then
%             raise illegalState(noContext) end
%          end
%          /*
%          if {@Context isStarted($)}==false then
%             {System.show "Handler Context not started for "#self}
%          end
%          */
%          LifeCycle, start()
%       end

      
%       meth stop()
%          LifeCycle, stop()
%       end
%       meth destroy()
%          LifeCycle, destroy()
%          Context <- unit
%       end
%       %%
%       */
